#ifndef _3D_GRID__
#define _3D_GRID__

#import <Foundation/Foundation.h>

#define DEFAULT_NUMBER	40

typedef struct TDPoint
{
    float x,y,z;
    
    // May be I need to add the u,v and Normal attributes
} TDPoint;

@interface TDGrid : NSObject
{
	@public

    float xmin_,xmax_;
    float ymin_,ymax_;
    float zmin_,zmax_;

    unsigned long rows_,columns_;
    TDPoint ** grid_;
}

- (id) init;
- (id) initWithRows:(unsigned long) inRows Columns:(unsigned long) inColumns;

- (float) xmin;
- (float) xmax;
- (float) ymin;
- (float) ymax;
- (float) zmin;
- (float) zmax;

- (void) computeBounds;

/*
- (void) setXmin:(float) inXmin;
- (void) setXmax:(float) inXmax;
- (void) setYmin:(float) inYmin;
- (void) setYmax:(float) inYmax;
- (void) setZmin:(float) inZmin;
- (void) setZmax:(float) inZmax;
*/
- (unsigned long) rows;
- (unsigned long) columns;

- (void) setRows:(unsigned long) inRows;
- (void) setColumns:(unsigned long) inColumns;
- (void) setRows:(unsigned long) inRows Columns:(unsigned long) inColumns;

- (TDPoint) valueAtRow:(unsigned long) inRow Column:(unsigned long) inColumn;

- (TDPoint **) grid;
- (void) setGrid: (TDPoint **) inGrid;

@end

#endif