#import "3DGrid.h"

@implementation TDGrid

//.............................................................

-(id) init
{
	[super init];

	grid_=NULL;
	rows_=0;
	columns_=0;

	return self;
}

//.............................................................

- (id) initWithRows:(unsigned long) inRows Columns:(unsigned long) inColumns
{
	[super init];

	grid_=NULL;
	rows_=inRows;
	columns_=inColumns;
	
	if (rows_*columns_>0)
	{
		grid_=(TDPoint **) malloc(rows_*sizeof(TDPoint *));
		
		if (grid_!=NULL)
		{
			unsigned long i=0;
			
			for(;i<rows_;i++)
			{
				grid_[i]=(TDPoint *) malloc(columns_*sizeof(TDPoint));
			}
		}
	}

	return self;
}

- (void) dealloc
{
    if (grid_!=NULL)
    {
        unsigned long i=0;

        for(;i<rows_;i++)
        {
            free(grid_[i]);
        }

        free(grid_);
    }

    [super dealloc];
}

//.............................................................

- (float) xmin
{
	return xmin_;
}

//.............................................................

- (float) xmax {
	return xmax_;
}

//.............................................................

- (float) ymin {
	return ymin_;
}

//.............................................................

- (float) ymax {
	return ymax_;
}

//.............................................................

- (float) zmin {
        return zmin_;
}

//.............................................................

- (float) zmax {
        return zmax_;
}

- (void) computeBounds
{
    unsigned long i,j;
    float tx,ty,tz;
    TDPoint * tpoint;
    
    xmin_=xmax_=grid_[0][0].x;
    ymin_=ymax_=grid_[0][0].y;
    zmin_=zmax_=grid_[0][0].z;
    
    for(i=0;i<rows_;i++)
    {
        for(j=0;j<columns_;j++)
        {
            tpoint=grid_[i]+j;
            
            tx=tpoint->x;
            ty=tpoint->y;
            tz=tpoint->z;
            
            if (tx<xmin_) xmin_=tx;
            else if (tx>xmax_) xmax_=tx;
            
            if (ty<ymin_) ymin_=ty;
            else if (ty>ymax_) ymax_=ty;
            
            if (tz<zmin_) zmin_=tz;
            else if (tz>zmax_) zmax_=tz;
        }
    }
}

/*
//.............................................................

- (void) setXmin:(float) inXmin
{
	xmin_=inXmin;
}

//.............................................................

- (void) setXmax:(float) inXmax
{
	xmax_=inXmax;
}

//.............................................................

- (void) setYmin:(float) inYmin
{
	ymin_=inYmin;
}

//.............................................................

- (void) setYmax:(float) inYmax
{
	ymax_=inYmax;
}

//.............................................................

- (void) setZmin:(float) inZmin
{
        zmin_=inZmin;
}

//.............................................................

- (void) setZmax:(float) inZmax
{
        zmax_=inZmax;
}
*/

//.............................................................

- (unsigned long) rows
{
	return rows_;
}

//.............................................................

- (unsigned long) columns
{
	return columns_;
}

//.............................................................

- (void) setRows:(unsigned long) inRows
{
	[self setRows:inRows Columns:columns_];
}

//.............................................................

- (void) setColumns:(unsigned long) inColumns
{
	
	if (grid_!=NULL && inColumns!=columns_)
	{
		unsigned long i;
		
		columns_=inColumns;
		
		for(i=0;i<rows_;i++)
		{
			free(grid_[i]);
			grid_[i]=(TDPoint *) malloc(columns_*sizeof(TDPoint));
		}
	}

}

//.............................................................

- (void) setRows:(unsigned long) inRows Columns:(unsigned long) inColumns
{
	if (grid_!=NULL)
	{
		unsigned long i=0;
		
		for(;i<rows_;i++)
		{
			free(grid_[i]);
		}
		
		free(grid_);
	}
	
	rows_=inRows;
	columns_=inColumns;
	
	grid_=(TDPoint **) malloc(rows_*sizeof(TDPoint *));
		
	if (grid_!=NULL)
	{
		unsigned long i=0;
			
		for(;i<rows_;i++)
		{
			grid_[i]=(TDPoint *) malloc(columns_*sizeof(TDPoint));
		}
	}
}

//.............................................................

- (TDPoint) valueAtRow:(unsigned long) inRow Column:(unsigned long) inColumn
{
	if (grid_!=NULL)
	{
		return grid_[inRow][inColumn];
        }
}

//.............................................................

- (TDPoint **) grid
{
	return grid_;
}

//.............................................................

- (void) setGrid: (TDPoint **) inGrid
{
	if (grid_!=NULL && grid_!=inGrid)
	{
		unsigned long i=0;
		
		for(;i<rows_;i++)
		{
			free(grid_[i]);
		}
		
		free(grid_);
	}
	
	grid_=inGrid;
}	

@end