#include "DXFImport.h"
#include <stdlib.h>
#include <stdio.h>
#include "SMColor.h"

char current_name[256];
char find_name[256];
char ligne1[256],ligne2[256];
char valeur[256];

#define LAYER_COLOR_COUNT 14

SMColor layerColor[]= {
    {1,0,0,0},
    {0,0,1,1},
    {0,1,0,1},
    {1,1,0,1},
    {1,0,1,1},
    
    {0,1,1,0},
    {0.5,0,0,1},
    {0,0.5,0,1},
    {0,0,0.5,1},
    {0.5,0.5,0,1},
    
    {0.5,0.5,1,1},
    {0.5,0,0.5,1},
    {0.5,0,1,1},
    {0.5,0.5,0.5,1}
};

LayerDescription * current_layer;

LayerDescription * FindLayer(SceneDescription * inSceneDescription,char * inLayerName)
{
    LayerDescription * tlayerDesc=inSceneDescription->layerArray_;
    
    while (tlayerDesc!=NULL)
    {
        if (!strcmp(tlayerDesc->name_,inLayerName))
            break;
        
        tlayerDesc=tlayerDesc->next_;
    }

    return tlayerDesc;
}

void AddLayer(SceneDescription * inSceneDescription,LayerDescription * inLayer)
{
    LayerDescription * tlayerDesc=inSceneDescription->layerArray_;
    
    if (tlayerDesc==NULL)
    {
        inSceneDescription->layerArray_=inLayer;
    }
    else
    {
        while (tlayerDesc->next_!=NULL)
        {
            tlayerDesc=tlayerDesc->next_;
        }
        
        tlayerDesc->next_=inLayer;
    }
    
    inSceneDescription->layerCount_++;
}

void getLayerPolyline(SMFile * inFile)
{
    int find_couche=0;

    SMFileReadLineTextBuffer(inFile,ligne1);
    SMFileReadLineTextBuffer(inFile,ligne2);

    // Determination du type de POLYLINE

    while (inFile->reachedEnd_==0 && strcmp(ligne2,"VERTEX")) {

        if (!strcmp(ligne1,"8"))
        {
            // Lecture de la couche

            if (find_couche==0)
            { // On n'a pas encore trouve la couche
                find_couche=1;
                strcpy(find_name,ligne2);
            }	
        }

        SMFileReadLineTextBuffer(inFile,ligne1);
        SMFileReadLineTextBuffer(inFile,ligne2);
    }
}

void FillPolylineStructure(SMFile * inFile,void * inPolyline)
{
	SM3DPoint p1;

	// Lecture des infos sur les Vertex

	// Remplissage en fonction du type d'objet
	
	switch(*(unsigned long *) inPolyline)
  {
        case POLYGON_ID:
            {
                SMPolygon * tPolygon=(SMPolygon *) inPolyline;
            
                while (inFile->reachedEnd_==0 && strcmp(ligne2,"SEQEND"))
                {
                    if (!strcmp(ligne2,"VERTEX"))
                    {
                        while (inFile->reachedEnd_==0 && strcmp(ligne1,"10"))
                        {
                            SMFileReadLineTextBuffer(inFile,ligne1);
                            SMFileReadLineTextBuffer(inFile,valeur);
                        }
        
                        p1.position_.x=readFloat(valeur);
                            
                        SMFileReadLineTextBuffer(inFile,ligne1);
                        SMFileReadLineTextBuffer(inFile,valeur);	// 20
                
                        p1.position_.y=readFloat(valeur);
                
                        SMFileReadLineTextBuffer(inFile,ligne1);
                        SMFileReadLineTextBuffer(inFile,valeur);	// 30
                        
                        p1.position_.z=readFloat(valeur);
        
                        tPolygon->vertices_[tPolygon->verticesCount_++]=p1;
                    }
                    
                    SMFileReadLineTextBuffer(inFile,ligne1);
                    SMFileReadLineTextBuffer(inFile,ligne2);
                }
            }
            break;
        case GRID_ID:
            {
                SMGrid * tGrid=(SMGrid *) inPolyline;
                
                while (inFile->reachedEnd_==0 && strcmp(ligne2,"SEQEND"))
                {
                    if (!strcmp(ligne2,"VERTEX"))
                    {
                        while (inFile->reachedEnd_==0 && strcmp(ligne1,"10"))
                        {
                            SMFileReadLineTextBuffer(inFile,ligne1);
                            SMFileReadLineTextBuffer(inFile,valeur);
                        }

                        p1.position_.x=readFloat(valeur);
						
                        SMFileReadLineTextBuffer(inFile,ligne1);
                        SMFileReadLineTextBuffer(inFile,valeur);	// 20
                        
                        p1.position_.y=readFloat(valeur);
                        
                        SMFileReadLineTextBuffer(inFile,ligne1);
                        SMFileReadLineTextBuffer(inFile,valeur);	// 30
                        
                        p1.position_.z=readFloat(valeur);
                        
                        tGrid->array_[tGrid->verticesCount_++]=p1;
                    }
                }
            }
            break;
        case MESH_ID:
            {
                SMMesh * tMesh=(SMMesh *) inPolyline;
                SMIndexedFace indexedFace;
                
                // Retrieve the Points
                
                while (inFile->reachedEnd_==0 && strcmp(ligne2,"SEQEND"))
                {
                    if (!strcmp(ligne2,"VERTEX"))
                    {
                        while (inFile->reachedEnd_==0 && strcmp(ligne1,"10"))
                        {
                            SMFileReadLineTextBuffer(inFile,ligne1);
                            SMFileReadLineTextBuffer(inFile,valeur);
                        }
        
                        p1.position_.x=readFloat(valeur);
                        
                        SMFileReadLineTextBuffer(inFile,ligne1);
                        SMFileReadLineTextBuffer(inFile,valeur);	// 20
                        
                        p1.position_.y=readFloat(valeur);
                        
                        SMFileReadLineTextBuffer(inFile,ligne1);
                        SMFileReadLineTextBuffer(inFile,valeur);	// 30
                        
                        p1.position_.z=readFloat(valeur);
        
                        tMesh->arrayPoint_[tMesh->verticesCount_++]=p1;
                        
                        if (tMesh->verticesCount_==tMesh->facesCount_) break;
                    }
                }
                
                tMesh->facesCount_=0;
                
                while (inFile->reachedEnd_==0 && strcmp(ligne2,"SEQEND"))
                {
                    if (!strcmp(ligne2,"VERTEX"))
                    {
                        while (inFile->reachedEnd_==0 && strcmp(ligne1,"71"))
                        {
                            SMFileReadLineTextBuffer(inFile,ligne1);
                            SMFileReadLineTextBuffer(inFile,valeur);
                        }
            
                        indexedFace.index_[0]=readFloat(valeur)-1;				// 71
                        
                        SMFileReadLineTextBuffer(inFile,ligne1);
                        SMFileReadLineTextBuffer(inFile,valeur);	// 72
                        
                        indexedFace.index_[1]=readFloat(valeur)-1;
                        
                        SMFileReadLineTextBuffer(inFile,ligne1);
                        SMFileReadLineTextBuffer(inFile,valeur);	// 73
                        
                        indexedFace.index_[2]=readFloat(valeur)-1;
                             
                        SMFileReadLineTextBuffer(inFile,ligne1);
                        SMFileReadLineTextBuffer(inFile,valeur);	// 74
                        
                        indexedFace.index_[3]=readFloat(valeur)-1;
                        
                        tMesh->arrayFace_[tMesh->facesCount_++]=indexedFace;
                    }
                    
                    SMFileReadLineTextBuffer(inFile,ligne1);
                    SMFileReadLineTextBuffer(inFile,ligne2);
                }
            }
            break;
    }
}

void ExtractPolylineInfo(SMFile * inFile,PolylineDescription * inPolylineDesc)
{
    int find_couche=0;
    
    SMFileReadLineTextBuffer(inFile,ligne1);
    SMFileReadLineTextBuffer(inFile,ligne2);
	
	// Determination du type de POLYLINE

	while (inFile->reachedEnd_==0 && strcmp(ligne2,"VERTEX"))
  {

		if (!strcmp(ligne1,"70"))
    {

			// Lecture du POLYLINE FLAG

			unsigned char kind;

			kind=(unsigned char ) readFloat(ligne2);

			if (kind==64)
      {
				inPolylineDesc->type_=kPOLYFACEMESH;
				break;
				
			}

			if (kind>=16 && kind <64)
      {

				inPolylineDesc->type_=kMESH;

				if ((kind & 0x01)==1) inPolylineDesc->attributes_|=kCloseV;

				if ((kind & 0x20)==1) inPolylineDesc->attributes_|=kCloseH;

			}
			else
      {

				inPolylineDesc->type_= kPOLYLINE;

				if ((kind & 0x01)==1) inPolylineDesc->attributes_|=kClose;

			}

		}

		else if (!strcmp(ligne1,"71"))
    {

			// Lecture du nombre de points verticaux

			inPolylineDesc->v_=(unsigned long) readFloat(ligne2);

		}

		else if (!strcmp(ligne1,"72"))
    {

			// Lecture du nombre de points horizontaux

			inPolylineDesc->h_=(unsigned long) readFloat(ligne2);

		}

		else if (!strcmp(ligne1,"8"))
    {

			// Lecture de la couche

			if (find_couche==0) // On n'a pas encore trouve la couche
      {

				find_couche=1;
	
				strcpy(find_name,ligne2);

			}	

		}

		SMFileReadLineTextBuffer(inFile,ligne1);
    SMFileReadLineTextBuffer(inFile,ligne2);

	}

	// Lecture des infos sur les Vertex

	while (inFile->reachedEnd_==0 && strcmp(ligne2,"SEQEND"))
  {

		if (!strcmp(ligne2,"VERTEX"))
    {
			
			inPolylineDesc->vertexCount_++;
		}
		
		if (!strcmp(ligne1,"70"))
    {
			if (!strcmp(ligne2,"128"))
      {
				// Si en fait le VERTEX sert a decrire une face, on ne le compte pas
				inPolylineDesc->vertexCount_--;
        inPolylineDesc->indexedFaceCount_++;
			}
		}

		SMFileReadLineTextBuffer(inFile,ligne1);
    SMFileReadLineTextBuffer(inFile,ligne2);

	}
}

void AddPolyline(LayerDescription * inLayer,PolylineDescription * inPolyline)
{
    PolylineDescription * tPolylineDesc=inLayer->polylineArray_;
    
    if (tPolylineDesc==NULL)
    {
        inLayer->polylineArray_=inPolyline;
    }
    else
    {
        while (tPolylineDesc->next_!=NULL)
        {
            tPolylineDesc=tPolylineDesc->next_;
        }
        
        tPolylineDesc->next_=inPolyline;
    }
    
    inLayer->polylineCount_++;
}

SceneDescription * ExtractFileInfo(SMFile * inFile)
{
    SceneDescription * tSceneDescription;
    
    current_name[0]='\0';
    find_name[0]='\0';
    current_layer=NULL;
    
    
    tSceneDescription = (SceneDescription *) malloc(sizeof(SceneDescription));
    tSceneDescription->layerCount_=0;
    tSceneDescription->layerArray_=NULL;
    tSceneDescription->comments_[0]='\0';
    
    SMFileStartTextBuffer(inFile);
    SMFileReadLineTextBuffer(inFile,ligne1);
    SMFileReadLineTextBuffer(inFile,ligne2);
    
    while ((inFile->reachedEnd_==0) && strcmp(ligne2,"EOF"))
    {
    
        // Lecture des commentaires ?
    
        if (!strcmp(ligne1,"999"))
        {
            if (tSceneDescription->comments_[0]=='\0')
                strcpy(tSceneDescription->comments_,ligne2);
        }
        else 
        {
            // Lecture d'un objet DXF ?
        
            if (!strcmp(ligne2,"3DFACE"))
            {
                // Lecture d'un 3DFACE
                
                do
                {
                    SMFileReadLineTextBuffer(inFile,ligne1);
                    SMFileReadLineTextBuffer(inFile,ligne2);
    
                    if (!strcmp(ligne1,"8"))
                    {
                        strcpy(find_name,ligne2);
                        break;
                    }
                } while (strcmp(ligne1,"10"));
        
            if (strcmp(find_name,current_name))
            {
                // On n'est pas sur la mme couche
        
                LayerDescription * temp;
        
                // Recherche de la couche
        
                temp=FindLayer(tSceneDescription,find_name);
        
                if (temp==NULL) {
        
                    // On n'a pas trouve de Couche ayant ce nom, on en cree donc une
                
                    temp= (LayerDescription *) malloc(sizeof(LayerDescription));
                
                    if (temp!=NULL)
                    {
                        temp->faceCount_=0;
                        temp->lineCount_=0;
                        temp->polylineCount_=0;
                        temp->polylineArray_=NULL;
                        temp->next_=NULL;
                        
                        strcpy(temp->name_,find_name);
                        
                        AddLayer(tSceneDescription,temp);
                        
                        current_layer=temp;
                        strcpy(current_name,find_name);
                    }
                }
                else
                {
                    // On a trouve la couche ayant ce nom
                    current_layer=temp;
                    strcpy(current_name,find_name);
                }	
            }
        
            current_layer->faceCount_++;
        }
        else if (!strcmp(ligne2,"3DLINE"))
        {
            // Lecture d'un 3DLINE
        
            do
            {
                SMFileReadLineTextBuffer(inFile,ligne1);
                SMFileReadLineTextBuffer(inFile,ligne2);
    
        
                if (!strcmp(ligne1,"8"))
                {
                    strcpy(find_name,ligne2);
                    break;
                }
        
            }
            while (strcmp(ligne1,"10"));
        
            if (strcmp(find_name,current_name))
            {
                // On n'est pas sur la meme couche
                LayerDescription * temp;
        
                // Recherche de la couche
                temp=FindLayer(tSceneDescription,find_name);
        
                if (temp==NULL)
                {
                    // On n'a pas trouve de Couche ayant ce nom, on en cree donc une
                    temp= (LayerDescription *) malloc(sizeof(LayerDescription));
            
                    if (temp!=NULL)
                    {
                        temp->faceCount_=0;
                        temp->lineCount_=0;
                        temp->polylineCount_=0;
                        temp->polylineArray_=NULL;
                        temp->next_=NULL;
                        
                        strcpy(temp->name_,find_name);
                        
                        AddLayer(tSceneDescription,temp);
                        
                        current_layer=temp;
                        strcpy(current_name,find_name);
                    }
                }
                else
                {
                    // On a trouve la couche ayant ce nom
                    current_layer=temp;
                    strcpy(current_name,find_name);
                }	
            }
            current_layer->lineCount_++;
        
        }
        else if (!strcmp(ligne2,"POLYLINE"))
        {
    
            // Lecture d'une POLYLINE
            PolylineDescription * nPolyline;
        
            nPolyline= (PolylineDescription *) malloc(sizeof(PolylineDescription));
            
            nPolyline->next_=NULL;
            nPolyline->type_=0;
            nPolyline->attributes_=0;
            nPolyline->indexedFaceCount_=0;
            nPolyline->vertexCount_=0;
            nPolyline->h_=nPolyline->v_=0;

            
            ExtractPolylineInfo(inFile,nPolyline);
        
            if (strcmp(find_name,current_name))
            {
                // On n'est pas sur la meme couche
                LayerDescription * temp;
        
                // Recherche de la couche
                temp=FindLayer(tSceneDescription,find_name);
        
                if (temp==NULL)
                {
                    // On n'a pas trouve de Couche ayant ce nom, on en cree donc une
                    temp= (LayerDescription *) malloc(sizeof(LayerDescription));
            
                    if (temp!=NULL)
                    {
                        temp->faceCount_=0;
                        temp->lineCount_=0;
                        temp->polylineCount_=0;
                        temp->polylineArray_=NULL;
                        temp->next_=NULL;
                        
                        strcpy(temp->name_,find_name);
                        
                        AddLayer(tSceneDescription,temp);
                        
                        current_layer=temp;
                        strcpy(current_name,find_name);
                    }
                }
                else
                {
                    // On a trouve la couche ayant ce nom
                    current_layer=temp;
                    strcpy(current_name,find_name);
                }	
            }
            
            AddPolyline(current_layer,nPolyline);
        }
    }
    
    SMFileReadLineTextBuffer(inFile,ligne1);
    SMFileReadLineTextBuffer(inFile,ligne2);

    }
    
    return tSceneDescription;
}

void * GetNextFreeObject(SMGroup * inGroup)
{
    SMGroup * tGroup=(SMGroup *) inGroup;
    unsigned long i;
    
    for(i=0;i<tGroup->subGroupCount_;i++)
    {
        switch(*((unsigned long *) tGroup->subGroupArray_[i]))
        {
            case POLYGON_ID:
                {
                    SMPolygon * tPolygon=(SMPolygon *) tGroup->subGroupArray_[i];
                    
                    if (tPolygon->verticesCount_==0) return tPolygon;
                
                }
                break;
            case GRID_ID:
                {
                    SMGrid * tGrid=(SMGrid *) tGroup->subGroupArray_[i];
                    
                    if (tGrid->verticesCount_==0) return tGrid;
                
                }
                break;
            case MESH_ID:
                {
                    SMMesh * tMesh=(SMMesh *) tGroup->subGroupArray_[i];
                    
                    if (tMesh->verticesCount_==0) return tMesh;
                }
                break;
        }
    }
    
    return NULL;
}

void * CreatePolyline(PolylineDescription * inPolylineDescription)
{
    switch(inPolylineDescription->type_)
    {
        case kPOLYLINE:
        {
            SMPolygon * tPolygon;
            
            tPolygon= (SMPolygon *) malloc(sizeof(SMPolygon));
            tPolygon->objectID_=POLYGON_ID;
            tPolygon->type_=inPolylineDescription->attributes_ & kClose;
            tPolygon->verticesCount_=0;
            
            tPolygon->vertices_=(SM3DPoint *) malloc(inPolylineDescription->vertexCount_*sizeof(SM3DPoint));
            return tPolygon;
        }
        case kMESH:
        {
            SMGrid * tGrid;
            
            tGrid= (SMGrid *) malloc(sizeof(SMGrid));
            tGrid->objectID_=GRID_ID;
            tGrid->verticesCount_=0;
            tGrid->hVerticesCount_=inPolylineDescription->h_;
            tGrid->vVerticesCount_=inPolylineDescription->v_;
            
            tGrid->array_=(SM3DPoint *) malloc(inPolylineDescription->vertexCount_*sizeof(SM3DPoint));
            
            return tGrid;
        }
        case kPOLYFACEMESH:
        {
            SMMesh * tMesh;
            
            tMesh= (SMMesh *) malloc(sizeof(SMMesh));
            tMesh->objectID_=MESH_ID;
            tMesh->verticesCount_=0;
            tMesh->facesCount_=inPolylineDescription->vertexCount_;
            
            tMesh->arrayPoint_=(SM3DPoint *) malloc(inPolylineDescription->vertexCount_*sizeof(SM3DPoint));
            tMesh->arrayFace_=(SMIndexedFace *) malloc(inPolylineDescription->indexedFaceCount_*sizeof(SMIndexedFace));
            
            return tMesh;
        }
    }
    
    return NULL;
}

SMScene * CreateScene(SceneDescription * inSceneDescription)
{
    unsigned long i;
    SMScene * tScene;
    LayerDescription * tDescription;
    SMGroup * root;
    
    tScene = (SMScene *) malloc(sizeof(SMScene));
    root=tScene->scene_= (SMGroup *) malloc(sizeof(SMGroup));
    root->objectID_=GROUP_ID;
    
    root->subGroupCount_=inSceneDescription->layerCount_;
    root->subGroupArray_=(void **) malloc(inSceneDescription->layerCount_*sizeof(void *));
    
    tScene->ambient_=white;
    tScene->diffuse_=/*root->specular_=*/white;
    
    /*printf("%s\n",inSceneDescription->comments_);
    printf("Number of layers: %d\n",inSceneDescription->layerCount_);*/
    
    tDescription=inSceneDescription->layerArray_;
    
    for(i=0;i<inSceneDescription->layerCount_;i++)
    {
        unsigned long j=0;
        unsigned long k=0;
        PolylineDescription * tPolyDescription;
        SMGroup * tGroup;
        
        
        tGroup = (SMGroup *) malloc(sizeof(SMGroup));
        tGroup->objectID_=GROUP_ID;
        strcpy(tGroup->name_,tDescription->name_);
        
        tGroup->diffuse_=tGroup->ambient_=layerColor[i%14];
        
        tGroup->subGroupCount_=tDescription->polylineCount_+ (tDescription->faceCount_ >0 ? 1: 0);
        tGroup->subGroupArray_=(void **) malloc(tGroup->subGroupCount_*sizeof(void *));
        
        if (tDescription->faceCount_>0)
        {
            SMFaceArray * tFaceArray;
            
            tFaceArray=(SMFaceArray *) malloc(sizeof(SMFaceArray));
            tFaceArray->objectID_=FACE_ARRAY_ID;
            tFaceArray->facesCount_=0;
            tFaceArray->array_=(SMFace *) malloc(tDescription->faceCount_*sizeof(SMFace));
            
            tGroup->subGroupArray_[k++]=tFaceArray;
        }
        
        root->subGroupArray_[i]=tGroup;
        
        if (tDescription->lineCount_>0)
        {
            SMLineArray * tLineArray;
            
            tLineArray=(SMLineArray *) malloc(sizeof(SMLineArray));
            tLineArray->objectID_=LINE_ARRAY_ID;
            tLineArray->linesCount_=0;
            tLineArray->array_=(SMLine *) malloc(tDescription->lineCount_*sizeof(SMLine));
            
            tGroup->subGroupArray_[k++]=tLineArray;
        }
        
       /*printf("\n%s\n",tDescription->name_);
       printf("Number of faces on Layer: %d\n",tDescription->faceCount_);
       printf("Number of lines on Layer: %d\n",tDescription->lineCount_);
       printf("Number of polylines on Layer: %d\n",tDescription->polylineCount_);*/
       
       tPolyDescription=tDescription->polylineArray_;
       
       for(j=0;j<tDescription->polylineCount_;j++)
       {
            void * tPolyline;
            
            // No support for the POLYLINE
            
            /*printf("Type: %d\n",tPolyDescription->type_);
            printf("Attributes: %d\n",tPolyDescription->attributes_);
            printf("Vertex count: %d\n",tPolyDescription->vertexCount_);*/
            
            tPolyline=CreatePolyline( tPolyDescription);
            
            tGroup->subGroupArray_[k++]=tPolyline;
            
            tPolyDescription=tPolyDescription->next_;
       }
        
       tDescription = tDescription->next_;
    }
    
    return tScene;
}

void FillSceneStructure(SMScene * inOutScene,SMFile * inFile)
{
	SMGroup * cCurrent=NULL;
	SMFaceArray * cFaceArray=NULL;
  SMLineArray * cLineArray=NULL;
	void * cPolyline=NULL;

	current_name[0]='\0';
	find_name[0]='\0';

	SMFileStartTextBuffer(inFile);
	SMFileReadLineTextBuffer(inFile,ligne1);
	SMFileReadLineTextBuffer(inFile,ligne2);

	while ((inFile->reachedEnd_==0) && strcmp(ligne2,"EOF"))
  {

    // Lecture d'un objet DXF ?

		if (!strcmp(ligne2,"3DFACE"))
    {
        SM3DPoint p1,p2,p3,p4;
        
        // Lecture d'un 3DFACE

        do
        {
            SMFileReadLineTextBuffer(inFile,ligne1);
            SMFileReadLineTextBuffer(inFile,ligne2);

            if (!strcmp(ligne1,"8"))
            {
                strcpy(find_name,ligne2);
                break;
            }
        }
        while (strcmp(ligne1,"10"));

        while ((inFile->reachedEnd_==0) && strcmp(ligne1,"10"))
        {
            SMFileReadLineTextBuffer(inFile,ligne1);
            SMFileReadLineTextBuffer(inFile,valeur);
        }

        p1.position_.x=readFloat(valeur);

        SMFileReadLineTextBuffer(inFile,ligne1);
        SMFileReadLineTextBuffer(inFile,valeur);	// 20

        p1.position_.y=readFloat(valeur);

        SMFileReadLineTextBuffer(inFile,ligne1);
				SMFileReadLineTextBuffer(inFile,valeur);	// 30
	
        p1.position_.z=readFloat(valeur);

        SMFileReadLineTextBuffer(inFile,ligne1);
				SMFileReadLineTextBuffer(inFile,valeur);	// 11

        p2.position_.x=readFloat(valeur);

        SMFileReadLineTextBuffer(inFile,ligne1);
        SMFileReadLineTextBuffer(inFile,valeur);	// 21

        p2.position_.y=readFloat(valeur);

        SMFileReadLineTextBuffer(inFile,ligne1);
				SMFileReadLineTextBuffer(inFile,valeur);	// 31
        
        p2.position_.z=readFloat(valeur);

        SMFileReadLineTextBuffer(inFile,ligne1);
				SMFileReadLineTextBuffer(inFile,valeur);	// 12

        p3.position_.x=readFloat(valeur);

        SMFileReadLineTextBuffer(inFile,ligne1);
        SMFileReadLineTextBuffer(inFile,valeur);	// 22

        p3.position_.y=readFloat(valeur);

        SMFileReadLineTextBuffer(inFile,ligne1);
				SMFileReadLineTextBuffer(inFile,valeur);	// 32
        
        p3.position_.z=readFloat(valeur);	

				SMFileReadLineTextBuffer(inFile,ligne1);
				SMFileReadLineTextBuffer(inFile,valeur);	// 13

        p4.position_.x=readFloat(valeur);

        SMFileReadLineTextBuffer(inFile,ligne1);
        SMFileReadLineTextBuffer(inFile,valeur);	// 23

        p4.position_.y=readFloat(valeur);

        SMFileReadLineTextBuffer(inFile,ligne1);
				SMFileReadLineTextBuffer(inFile,valeur);	// 33
        
        p4.position_.z=readFloat(valeur);

        if (strcmp(find_name,current_name))
        {
            // On n'est pas sur la meme couche
			
            // Recherche de la couche
				
            cCurrent=SMSceneFindGroup(inOutScene,find_name);

            if (cCurrent!=NULL) {	// On a trouve la couche ayant ce nom
                cFaceArray=(SMFaceArray *) SMGroupFindFirstTypedObject(cCurrent,FACE_ARRAY_ID);
                cLineArray=(SMLineArray *) SMGroupFindFirstTypedObject(cCurrent,LINE_ARRAY_ID);
                strcpy(current_name,find_name);
            }
        }

        if (cFaceArray!=NULL)
        {
            unsigned char tCount=3;
            
            if (p3.position_.x!=p4.position_.x || p3.position_.y!=p4.position_.y || p3.position_.z!=p4.position_.z)
                tCount=4;

            cFaceArray->array_[cFaceArray->facesCount_].verticesCount_=tCount;
            cFaceArray->array_[cFaceArray->facesCount_].vertices_[0]=p1;
            cFaceArray->array_[cFaceArray->facesCount_].vertices_[1]=p2;
            cFaceArray->array_[cFaceArray->facesCount_].vertices_[2]=p3;
            if (tCount==4)
                cFaceArray->array_[cFaceArray->facesCount_].vertices_[3]=p4;
            
            cFaceArray->facesCount_++;
        }
		}
		else if (!strcmp(ligne2,"3DLINE"))
    {
        SM3DPoint p1,p2;
        
        // Lecture d'un 3DLINE
    
        do
        {
            SMFileReadLineTextBuffer(inFile,ligne1);
            SMFileReadLineTextBuffer(inFile,ligne2);
    
            if (!strcmp(ligne1,"8"))
            {
                strcpy(find_name,ligne2);
                break;
            }
        }
        while (strcmp(ligne1,"10"));
    
        while ((inFile->reachedEnd_==0) && strcmp(ligne1,"10"))
        {
            SMFileReadLineTextBuffer(inFile,ligne1);
            SMFileReadLineTextBuffer(inFile,valeur);
        }
    
        p1.position_.x=readFloat(valeur);
    
        SMFileReadLineTextBuffer(inFile,ligne1);
        SMFileReadLineTextBuffer(inFile,valeur);	// 20
    
        p1.position_.y=readFloat(valeur);
    
        SMFileReadLineTextBuffer(inFile,ligne1);
        SMFileReadLineTextBuffer(inFile,valeur);	// 30
    
        p1.position_.z=readFloat(valeur);
    
        SMFileReadLineTextBuffer(inFile,ligne1);
        SMFileReadLineTextBuffer(inFile,valeur);	// 11
    
        p2.position_.x=readFloat(valeur);
    
        SMFileReadLineTextBuffer(inFile,ligne1);
        SMFileReadLineTextBuffer(inFile,valeur);	// 21
    
        p2.position_.y=readFloat(valeur);
    
        SMFileReadLineTextBuffer(inFile,ligne1);
        SMFileReadLineTextBuffer(inFile,valeur);	// 31
    
        p2.position_.z=readFloat(valeur);

        if (strcmp(find_name,current_name))
        {
            // On n'est pas sur la meme couche

            // Recherche de la couche
            cCurrent=SMSceneFindGroup(inOutScene,find_name);

            if (cCurrent!=NULL)
            {	// On a trouve la couche ayant ce nom
                cFaceArray=(SMFaceArray *) SMGroupFindFirstTypedObject(cCurrent,FACE_ARRAY_ID);
                cLineArray=(SMLineArray *) SMGroupFindFirstTypedObject(cCurrent,LINE_ARRAY_ID);
                strcpy(current_name,find_name);
            }
				}
        
        if (cLineArray!=NULL)
        {
            cLineArray->array_[cLineArray->linesCount_].a_=p1;
            cLineArray->array_[cLineArray->linesCount_++].b_=p2;
				}
			
		}
		else if (!strcmp(ligne2,"POLYLINE"))
    {

        // Lecture d'une POLYLINE

        getLayerPolyline(inFile);

        if (strcmp(find_name,current_name))
        {

            // On n'est pas sur la meme couche

            // Recherche de la couche
            
            cCurrent=SMSceneFindGroup(inOutScene,find_name);

            if (cCurrent!=NULL)
            {	// On a trouve la couche ayant ce nom
                cFaceArray=(SMFaceArray *) SMGroupFindFirstTypedObject(cCurrent,FACE_ARRAY_ID);
                cLineArray=(SMLineArray *) SMGroupFindFirstTypedObject(cCurrent,LINE_ARRAY_ID);
                strcpy(current_name,find_name);
            }	
        }
        
        cPolyline=GetNextFreeObject(cCurrent);
        
        if (cPolyline!=NULL) FillPolylineStructure(inFile,cPolyline);
		}

		SMFileReadLineTextBuffer(inFile,ligne1);
    SMFileReadLineTextBuffer(inFile,ligne2);

	}
}

SMScene * ImportDXF(char * inPathName)
{
    SMFile * DXFFile;
    SMScene * nScene=NULL;
    DXFFile=SMFileOpen(inPathName);
    
    if (DXFFile!=NULL)
    {
        SceneDescription * tSceneDescription;
        
        tSceneDescription=ExtractFileInfo(DXFFile);
        
        if (tSceneDescription !=NULL && tSceneDescription->layerCount_>0)
        {
            nScene = CreateScene(tSceneDescription);
            
            if (nScene!=NULL)
            {
                FillSceneStructure(nScene,DXFFile);
            }
        }
        
        if (tSceneDescription!=NULL)
        {
            DeleteSceneDescription(tSceneDescription);
        }
    }
    
    return nScene;
}

void DeleteSceneDescription(SceneDescription * inSceneDescription)
{
    if (inSceneDescription->layerArray_!=NULL)
    {
        DeleteLayerDescription(inSceneDescription->layerArray_);
    }
    
    free(inSceneDescription);
}

void DeleteLayerDescription(LayerDescription * inLayerDescription)
{
    if (inLayerDescription->next_!=NULL)
    {
        DeleteLayerDescription(inLayerDescription->next_);
    }
    
    if (inLayerDescription->polylineArray_!=NULL)
    {
        DeletePolylineDescription(inLayerDescription->polylineArray_);
    }
    
    free(inLayerDescription);
}

void DeletePolylineDescription(PolylineDescription * inPolylineDescription)
{
    if (inPolylineDescription->next_!=NULL)
    {
        DeletePolylineDescription(inPolylineDescription->next_);
    }
    
    free(inPolylineDescription);
}

float readFloat(char * inString)
{
	int i=0,j,k;
	float temp=0,temp2;
	int signe=1;

	if (inString[0]=='-')
  {
		signe=-1;
		i++;
	}

	while (inString[i]>47 && inString[i]<58 && inString[i]!='\0')
  {
		temp=temp*10+(inString[i]-48);
		i++;
	}

	if (inString[i]=='.') {

		i++;
		j=1;

		while (inString[i]>47 && inString[i]<58 && inString[i]!='\0')
    {
			temp2=(inString[i]-48);
			for(k=0;k<j;k++) temp2/=10;
			temp=temp+temp2;
			i++;
			j++;
		}

	}

	return (signe*temp);
}