#import <AppKit/AppKit.h>
#import <AppKit/NSOpenGL.h>

#include "SMScene.h"


enum {
    kSMAqua,
    kSMtoto,
    kSMZebra
};

@interface OpenGLView : NSOpenGLView
{
    
    SMScene * scene_;
    
    BOOL needDisplay_;

    BOOL wireFrame_;
    unsigned short shadingMode_;

    float rotX_,rotY_,rotZ_;

    float centerX_,centerY_,centerZ_;

    float zoom_;

    float scale_;

    float deltaRotY_;
    
    BOOL showAxis_;
    BOOL showFog_;

    NSTimer * timer_;
}

- (SMScene *) scene;
- (void) setScene:(SMScene *) inScene;

- (void) render;

- (void) computeViewDatas;
- (void) setShadeMode:(unsigned short) inShadingMode;

- (void) manageLights;

- (void) shapeView;

- (void) animate:(id) sender;

- (void) setDrawingModeWireFrame:(BOOL) inWireFrame;

@end
