#include "SMBounding.h"
#include "SMKit.h"
#include <stdlib.h>
#include <stdio.h>

SMBoundingEngine gBoundingEngine;

void InitBoundingEngine(void)
{
    unsigned long i=0;
    
    gBoundingEngine.boundingCallBackCount_=SMSD_TYPEDOBJECT_COUNT;
    
    gBoundingEngine.array_= (SMGetMinMax *) malloc(SMSD_TYPEDOBJECT_COUNT*sizeof(SMGetMinMax));
    
    gBoundingEngine.array_[i++]=SMGroupGetMinMax;
    gBoundingEngine.array_[i++]=SMFaceArrayGetMinMax;
    gBoundingEngine.array_[i++]=SMGridGetMinMax;
    gBoundingEngine.array_[i++]=SMPolygonGetMinMax;
    gBoundingEngine.array_[i++]=SMMeshGetMinMax;
    gBoundingEngine.array_[i++]=SMLineArrayGetMinMax;
}

void SMSceneGetMinMax(SMScene * inScene)
{
    SMGroupGetMinMax(inScene->scene_,&inScene->min_,&inScene->max_);
    
    /*printf("%f %f %f\n",inScene->min_.x,inScene->min_.y,inScene->min_.z);
    printf("%f %f %f\n",inScene->max_.x,inScene->max_.y,inScene->max_.z);*/
}

void SMFaceArrayGetMinMax(void * inFaceArray,SMPoint * inOutMin,SMPoint * inOutMax)
{
    SMFaceArray * tFaceArray=(SMFaceArray *) inFaceArray;
    unsigned long i;
    
    for(i=0;i<tFaceArray->facesCount_;i++)
    {
        SMFace * tFace=tFaceArray->array_+i;
        unsigned long j;
        
        for(j=0;j<tFace->verticesCount_;j++)
        {
            SMPointGetMinMax(&tFace->vertices_[j].position_,inOutMin,inOutMax);
        }
    }
}

void SMFaceGetMinMax(void * inFace,SMPoint * inOutMin,SMPoint * inOutMax)
{
    SMFace * tFace=(SMFace *) inFace;
    unsigned long i;
    
    for(i=0;i<tFace->verticesCount_;i++)
    {
        SMPointGetMinMax(&tFace->vertices_[i].position_,inOutMin,inOutMax);
    }
}

void SMGroupGetMinMax(void * inGroup,SMPoint * inOutMin,SMPoint * inOutMax)
{
    SMGroup * tGroup=(SMGroup *) inGroup;
    unsigned long i;
    
    for(i=0;i<tGroup->subGroupCount_;i++)
    {
        gBoundingEngine.array_[*((unsigned long *) tGroup->subGroupArray_[i])](tGroup->subGroupArray_[i],inOutMin,inOutMax);
    }
}

void SMGridGetMinMax(void * inGrid,SMPoint * inOutMin,SMPoint * inOutMax)
{
    SMGrid * tGrid=(SMGrid *) inGrid;
    
    unsigned long i;
    
    for(i=0;i<tGrid->verticesCount_;i++)
    {
        SMPointGetMinMax(&tGrid->array_[i].position_,inOutMin,inOutMax);
    }
}

void SMMeshGetMinMax(void * inMesh,SMPoint * inOutMin,SMPoint * inOutMax)
{
    SMMesh * tMesh=(SMMesh *) inMesh;
    unsigned long i;
    
    for(i=0;i<tMesh->verticesCount_;i++)
    {
        SMPointGetMinMax(&tMesh->arrayPoint_[i].position_,inOutMin,inOutMax);
    }
}

void SMPolygonGetMinMax(void * inPolygon,SMPoint * inOutMin,SMPoint * inOutMax)
{
    SMPolygon * tPolygon=(SMPolygon *) inPolygon;
    unsigned long i;
    
    for(i=0;i<tPolygon->verticesCount_;i++)
    {
        SMPointGetMinMax(&tPolygon->vertices_[i].position_,inOutMin,inOutMax);
    }
}

void SMLineArrayGetMinMax(void * inLineArray,SMPoint * inOutMin,SMPoint * inOutMax)
{
    SMLineArray * tLineArray=(SMLineArray *) inLineArray;
    
    unsigned long i;
    
    for(i=0;i<tLineArray->linesCount_;i++)
    {
        SMPointGetMinMax(&tLineArray->array_[i].a_.position_,inOutMin,inOutMax);
        SMPointGetMinMax(&tLineArray->array_[i].b_.position_,inOutMin,inOutMax);
    }
}
