#include "SMDeleteEngine.h"
#include "SMKit.h"
#include <stdlib.h>

SMDeleteEngine gDeleteEngine;

void InitDeleteEngine(void)
{
    unsigned long i=0;
    
    gDeleteEngine.deleteCallBackCount_=SMSD_TYPEDOBJECT_COUNT;
    
    gDeleteEngine.array_= (SMDelete *) malloc(SMSD_TYPEDOBJECT_COUNT*sizeof(SMDelete));
    
    gDeleteEngine.array_[i++]=SMGroupDelete;
    gDeleteEngine.array_[i++]=SMFaceArrayDelete;
    gDeleteEngine.array_[i++]=SMGridDelete;
    gDeleteEngine.array_[i++]=SMPolygonDelete;
    gDeleteEngine.array_[i++]=SMMeshDelete;
    gDeleteEngine.array_[i++]=SMLineArrayDelete;
}

void SMSceneDelete(SMScene * inScene)
{
    SMGroupDelete(inScene->scene_);
    free(inScene);
}

void SMGroupDelete(void * inGroup)
{
    SMGroup * tGroup=(SMGroup *) inGroup;
    unsigned long i;
    
    for(i=0;i<tGroup->subGroupCount_;i++)
    {
        gDeleteEngine.array_[*((unsigned long *) tGroup->subGroupArray_[i])](tGroup->subGroupArray_[i]);
    }
    
    if (tGroup->subGroupArray_!=NULL)
        free(tGroup->subGroupArray_);
    
    free(tGroup);
}

void SMFaceArrayDelete(void * inFaceArray)
{
    SMFaceArray * tFaceArray=(SMFaceArray *) inFaceArray;
    
    if (tFaceArray->array_!=NULL)
        free(tFaceArray->array_);
    
    free(tFaceArray);
}

void SMGridDelete(void * inGrid)
{
    SMGrid * tGrid=(SMGrid *) inGrid;
    
    if (tGrid->array_!=NULL)
        free(tGrid->array_);
    
    free(tGrid);
}

void SMPolygonDelete(void * inPolygon)
{
    SMPolygon * tPolygon=(SMPolygon *) inPolygon;
    
    if (tPolygon->vertices_!=NULL)
        free(tPolygon->vertices_);
    
    free(tPolygon);
}

void SMMeshDelete(void * inMesh)
{
    SMMesh * tMesh=(SMMesh *) inMesh;
    
    if (tMesh->arrayPoint_!=NULL)
        free(tMesh->arrayPoint_);
    
    if (tMesh->arrayFace_!=NULL)
        free(tMesh->arrayFace_);
    
    free(tMesh);
}

void SMLineArrayDelete(void * inLineArray)
{
    SMLineArray * tLineArray=(SMLineArray *) inLineArray;
    
    if (tLineArray->array_!=NULL)
        free(tLineArray->array_);
        
    free(tLineArray);
}