#ifndef __SMDRAWINGENGINE__
#define __SMDRAWINGENGINE__

#ifndef __SMSHAREDDATA__
#include "SMSharedData.h"
#endif

#ifndef __SMSCENE__
#include "SMScene.h"
#endif

enum
{
    SM_WIREFRAME,
    SM_FILLED
};

enum
{
    SM_SCENE_COLOR,
    SM_LAYER_COLOR
};

typedef void (*SMDraw)(void *);

typedef struct SMDrawingEngine
{
    unsigned long drawingCallBackCount_;

    SMDraw * array_;
    
    int renderingMode_;
    int coloringMode_;
    
} SMDrawingEngine;

void InitDrawingEngine(void);

void SetRenderingMode(int);

void SetColoringMode(int);
int GetColoringMode(void);

void SMSceneDraw(SMScene * inScene);
void SMGroupDraw(void *);
void SMFaceArrayDraw(void *);
void SMGridDraw(void *);
void SMPolygonDraw(void *);
void SMMeshDraw(void *);
void SMLineArrayDraw(void *);

#endif