#include "SMFile.h"
#include <stdlib.h>

SMFile * SMFileOpen(char * inPathName)
{
    FILE * fp;
    SMFile * tFile=NULL;
    
    fp=fopen(inPathName,"rw");
    if (fp!=NULL)
    {
        tFile = (SMFile *) malloc(sizeof(SMFile));
        
        tFile->file_=fp;
        
        tFile->buffer_=NULL;
        tFile->readIndex_= tFile->bufferIndex_= tFile->bufferSize_=0;
        tFile->reachedEnd_=0;
        
        tFile->fileSize_=SMFileCalcFileSize(tFile);
    }
    return tFile;
}

int SMFileClose(SMFile * inFile)
{
    return fclose(inFile->file_);
}

long SMFileCalcFileSize(SMFile * inFile)
{
    fpos_t current_pos;

    fgetpos(inFile->file_,&current_pos);

    fseek(inFile->file_,0,SEEK_END);

    inFile->fileSize_=ftell(inFile->file_);

    fseek(inFile->file_,current_pos,SEEK_SET);

    return inFile->fileSize_;
}

int SMFileStartTextBuffer(SMFile * inFile)
{

	if (inFile->buffer_==NULL) {
		inFile->buffer_= (char *) malloc(MAX_TEXTBUFFER*sizeof(char));
		if (inFile->buffer_==NULL) {
			return 1;
		}
	}

	inFile->bufferIndex_=0;
	inFile->readIndex_=0;

	fseek(inFile->file_,0,SEEK_SET);
	
	inFile->fileSize_=SMFileCalcFileSize(inFile);

	if (inFile->fileSize_>MAX_TEXTBUFFER) inFile->bufferSize_=MAX_TEXTBUFFER;
	else inFile->bufferSize_=inFile->fileSize_;

	fread(inFile->buffer_,inFile->bufferSize_,1,inFile->file_);

	inFile->readIndex_+=inFile->bufferSize_;

	inFile->reachedEnd_=0;

	return 0;
}

int SMFileReadLineTextBuffer(SMFile * inFile,char *outString)
{
    if (inFile->bufferIndex_+MAX_LINE>inFile->bufferSize_) {	// plus assez de place

        if (inFile->readIndex_<inFile->fileSize_) {
    
        long ntraite;
        long counts;	
    
        // Copier ce qui reste au dbut
    
        memcpy(inFile->buffer_,&inFile->buffer_[inFile->bufferIndex_],inFile->bufferSize_-inFile->bufferIndex_);
    
        // Lire la suite
    
        ntraite=inFile->bufferSize_-inFile->bufferIndex_;
    
        if ((MAX_TEXTBUFFER+inFile->readIndex_-ntraite)>inFile->fileSize_)
            inFile->bufferSize_=inFile->fileSize_-inFile->readIndex_+ntraite;
        else
            inFile->bufferSize_=MAX_TEXTBUFFER;
    
        counts=inFile->bufferSize_-ntraite;
    
        fread(&inFile->buffer_[ntraite],counts,1,inFile->file_);
    
        // readIndex_+=bufferSize_
    
        inFile->readIndex_+=counts;
    
        inFile->bufferIndex_=0;
    
        }
    
        else if (inFile->bufferIndex_>=inFile->bufferSize_) {
        inFile->reachedEnd_=1;
        return 1;
    
        }
	}

	// Lecture ligne place+=longueur;	

	{
  long i=-1;

	register long tplace=inFile->bufferIndex_;

	while (inFile->buffer_[tplace]==' ' || inFile->buffer_[tplace]=='\t' || inFile->buffer_[tplace]=='\r' || inFile->buffer_[tplace]=='\n') tplace++;
	
	do {
		outString[i+1]=inFile->buffer_[tplace];
		i++;
		tplace++;
	}

	while (outString[i]!='\r' && outString[i]!='\n' && i<MAX_LINE);

	outString[i]='\0';

	inFile->bufferIndex_=tplace;
	}
	return 0;
}

int SMFileEndTextBuffer(SMFile * inFile)
{
    if (inFile->buffer_!=NULL)
    {
        inFile->bufferIndex_=0;
        free(inFile->buffer_);
        inFile->bufferSize_=0;
    }
    
    return 0;
}