#include "SMPoint.h"
#include <math.h>

void SMPointGetMax(SMPoint * inPoint,SMPoint * inOutMax)
{
    if (inPoint->x > inOutMax->x) inOutMax->x=inPoint->x;
    if (inPoint->y > inOutMax->y) inOutMax->y=inPoint->y;
    if (inPoint->z > inOutMax->z) inOutMax->z=inPoint->z;
}

void SMPointGetMin(SMPoint * inPoint,SMPoint * inOutMin)
{
    if (inPoint->x < inOutMin->x) inOutMin->x=inPoint->x;
    if (inPoint->y < inOutMin->y) inOutMin->y=inPoint->y;
    if (inPoint->z < inOutMin->z) inOutMin->z=inPoint->z;
}

void SMPointGetMinMax(SMPoint * inPoint,SMPoint * inOutMin,SMPoint * inOutMax)
{
    if (inPoint->x < inOutMin->x) inOutMin->x=inPoint->x;
    if (inPoint->x > inOutMax->x) inOutMax->x=inPoint->x;
    if (inPoint->y < inOutMin->y) inOutMin->y=inPoint->y;
    if (inPoint->y > inOutMax->y) inOutMax->y=inPoint->y;
    if (inPoint->z < inOutMin->z) inOutMin->z=inPoint->z;
    if (inPoint->z > inOutMax->z) inOutMax->z=inPoint->z;
}

SMNormalVector SMPointComputeNormal(SMPoint p1,SMPoint p2,SMPoint p3)
{
    float ux,uy,uz;
    float vx,vy,vz;
    float wx,wy,wz;
    float norm;
    SMNormalVector outNormal;
    
    ux=p2.x-p1.x;
    uy=p2.y-p1.y;
    uz=p2.z-p1.z;
    
    vx=p3.x-p1.x;
    vy=p3.y-p1.y;
    vz=p3.z-p1.z;
    
    
    wx=uy*vz-uz*vy;
    wy=uz*vx-ux*vz;
    wz=ux*vy-uy*vx;

    norm=sqrt(wx*wx+wy*wy+wz*wz);
    if (norm>0)
    {
        wx/=norm;
        wy/=norm;
        wz/=norm;
    }

    outNormal.x=-wx;
    outNormal.y=-wy;
    outNormal.z=-wz;
    
    return outNormal;
}

SMVector NormalizeVector(SMVector inVector)
{
    SMVector outVector=inVector;
    float norm=sqrt(outVector.x*outVector.x+outVector.y*outVector.y+outVector.z*outVector.z);
    
    outVector.x/=norm;
    outVector.y/=norm;
    outVector.z/=norm;
    
    return outVector;
}

SMVector AddVector(SMVector inVect1,SMVector inVect2)
{
    SMVector result;
    
    result.x=inVect1.x+inVect2.x;
    result.y=inVect1.y+inVect2.y;
    result.z=inVect1.z+inVect2.z;
    
    return result;
}

SMVector ScaleVector(SMVector inVector,float inRatio)
{
    SMVector result;
    
    result.x=inVector.x*inRatio;
    result.y=inVector.y*inRatio;
    result.z=inVector.z*inRatio;
    
    return result;
}