#ifndef __SMPOINT__
#define __SMPOINT__

typedef struct SMPoint
{
    float x;
    float y;
    float z;
} SMPoint;

typedef SMPoint SMVector;

typedef SMVector SMNormalVector;

typedef struct SMUVCoordinates
{
    float u;
    float v;
} SMUVCoordinates;

typedef struct SM3DPoint
{
    SMPoint					position_;
    SMNormalVector	normal_;
    SMUVCoordinates	uv_;
} SM3DPoint;

void SMPointGetMax(SMPoint * inPoint,SMPoint * inOutMax);
void SMPointGetMin(SMPoint * inPoint,SMPoint * inOutMin);
void SMPointGetMinMax(SMPoint * inPoint,SMPoint * inOutMin,SMPoint * inOutMax);

SMVector AddVector(SMVector,SMVector);
SMVector ScaleVector(SMVector,float);
SMVector NormalizeVector(SMVector);

SMNormalVector SMPointComputeNormal(SMPoint p1,SMPoint p2,SMPoint p3);

#endif